<?php
# $Id: pgsql.php,v 1.2 2003/01/05 13:05:40 pruet Exp $
# PostgreSQL abstract layer, grab some part form phpwiki
define("DB_NAME", "pgsql");
define("DB_VER", "0.0.1");
define("DB_INSERT_ID", TRUE);
class Database {
	var $conn;
	var $result;
	function Database($host = "localhost", $port,  $user = "", $pass = "", $udb = "")
	{
		if($udb == "") {
			debug(ERROR, DB_NAME, "Please specific database");
		} else {
			$cnxstr = $host?"host=$host ":"";
			$cnxstr .= $port?"port=$port ":"";
			$cnxstr .= $udb?"dbname=$udb ":"";
			if(!($this->$conn = pg_pconnect($cnxstr))) {
				debug(ERROR, DB_NAME, pg_errormessage($conn)); 
			}
		}
	}
	function query($query)
	{
		$this->$result = pg_exec($this->$conn, $query);
		if(!$this->$result) {
			debug(ERROR, DB_NAME, pg_errormessage($conn)); 
			return FALSE;
		}
		return $this->$result;
	}
	function insert($query)
	{
		$this->$result = pg_exec($this->$conn, $query);
		if(!$this->$result) {
			debug(ERROR, DB_NAME, pg_errormessage($conn)); 
			return FALSE;
		}
		return pg_getlastoid($this->$result);
	}
	function numrows($resultset)
	{
		if($resultset) {
			return pg_numrows($resultset);
		} else {
			return 0;
		}
	}
	function result($resultset, $row, $field)
	{
		if($resultset) {
			return pg_result($resultset, $row, $field);
		} else {
			return null; 
		}
	}
	function fetch($resultset)
	{
		if($resultset) {
			return pg_fetch_array($resultset);
		} else {
			return null;
		}
	}
	function seek($resultset, $row)
	{
		if($row < 0) {
			return FALSE;
		}
		if($resultset) {
			return pg_result_seek($resultset, $row);
		} else {
			return FALSE;
		}
	}
	function error()
	{
		return pg_errormessage($this->$conn);
	}
	function close($resultset)
	{
		return pg_free_result($resultset);
	}
}
?>
