<?php
# $Id: linker.php,v 1.1.1.1 2003/01/03 10:42:07 pruet Exp $
# Linker - Multi Tree Base Hierarchy Management Agent
define("LINKER_VER", "0.0.1");
define("LINKER_NAME", "linker");
define("LINKER_RECV_MESG", TRUE);
define("LINKER_DB", DEFAULT_DB);
define("TREE_TBL", "tree");
define("LNK_EMPTY_VALUE", 100);
define("LNK_UNKNOW_CMD", 105);

function loopsort($a, $b)
{
	$a = $a[tag];
	$b = $b[tag];
	$ca = count($a);
	$cb = count($b);
	$c = ($ca > $cb) ? $ca : $cb;
	for($i = 0; $i != $c; $i++) {
		if($i > $ca) {
			return 1;
		} elseif($i > $cb) {
			return -1;
		} elseif($a[$i] > $b[$i]) {
			return 1;
		} elseif($a[$i] < $b[$i]) {
			return -1;
		}
	}
	return 0;
}
function linker_destroy_db()
{
	$mesg = new Message(KEEPER_NAME, LINKER_NAME, "query");
	$mesg->set_header("DBName", LINKER_DB);
	$mesg->content = "DROP TABLE " . TREE_TBL;
	return send_message($mesg);
}
function linker_init_db()
{
	$mesg = new Message(KEEPER_NAME, LINKER_NAME, "query");
	$mesg->set_header("DBName", LINKER_DB);
	$mesg->content = "CREATE TABLE  " . TREE_TBL . " ("
			. "id SERIAL PRIMARY KEY, "
			. "name varCHAR(255) NOT NULL, "
			. "parent_id INT NOT NULL, "
			. "tag varchar(255), "
			. "level int NOT NULL )";
	return send_message($mesg);
}
function linker_get_tag($mesg)
{
	$id = (int)$mesg->get_header("id");
	$parent = (int)$mesg->get_header("parent");
	if(($id == "" || !is_integer($id) || $id == 0) && ($parent == "" || !is_integer($parent) || $parent == 0)) {
		$mesg->subject = ERROR;
		$mesg->content = LNK_EMPTY_VALUE;
		debug(ERROR, LINKER_NAME, $mesg->content);
		return $mesg;
	}
	$id = ($id == "") ? $parent : $id;
	$mesg->set(KEEPER_NAME, LINKER_NAME, "query");
	$mesg->content = "select tag, level from " . TREE_TBL . " where id = $id";
	$mesg->set_header("DBName", LINKER_DB);
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, LINKER_NAME, "fetch");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set_header("Level", $mesg->content[level]);
	$mesg->content = $mesg->content[tag];
	return $mesg;
}
function linker_get_name($mesg)
{
	$id = (int)$mesg->get_header("id");
	if(!is_integer($id) || $id == 0) {
		$mesg->subject = ERROR;
		$mesg->content = LNK_EMPTY_VALUE;
		debug(ERROR, LINKER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, LINKER_NAME, "query");
	$mesg->set_header("DBName", LINKER_DB);
	$mesg->content = "select name from " . TREE_TBL . " where id = $id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, LINKER_NAME, "fetch");
	$mesg->set_header("DBName", LINKER_DB);
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->content = $mesg->content[name];
	return $mesg;
}
function linker_get_flist($mesg)
{
	$parent = (int)$mesg->get_header("parent");
	if($parent == "")
		$parent = 0;
	if(!is_integer($parent)) {
		$mesg->subject = ERROR;
		$mesg->content = LNK_EMPTY_VALUE;
		debug(ERROR, LINKER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, LINKER_NAME, "query");
	$mesg->set_header("DBName", LINKER_DB);
	if($parent == 0) {
		$mesg->content = "select id, tag, name, level, parent_id from " . TREE_TBL . " order by id";
	} else {
		$mesg->content = "select id, tag, name, level, parent_id from " . TREE_TBL . " where tag like '%|$parent|%' order by id";
	}
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, LINKER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$numrows = $mesg->content;
	$flist = array();
	for($i = 0; $i != $numrows; $i++) {
		$mesg->set(KEEPER_NAME, LINKER_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$flist[$mesg->content[id]] = array(
			"name" => $mesg->content[name],
			"level" => $mesg->content[level],
			"parent_id" => $mesg->content[parent_id],
			"tag" => explode("|", $mesg->content[tag])
		);
	}
	$mesg->subject = OK;
	$mesg->set_header("NumParent", $numrows);
	uasort($flist, loopsort);
	$mesg->content = $flist;
	return $mesg;
}
function linker_del($mesg)
{
	$parent = (int)$mesg->get_header("parent");
	if(!is_integer($parent)) {
		$mesg->subject = ERROR;
		$mesg->content = LNK_EMPTY_VALUE;
		debug(ERROR, LINKER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, LIKER_NAME, "query");
	$mesg->set_header("DBName", LIKER_NAME);
	$mesg->content = "DELETE FROM " . TREE_TBL
		. " where tag like \"%|$parent|%\"";
	return send_message($mesg);
}
function linker_add($mesg)
{
	$parent = (int)$mesg->get_header("parent");
	$name = $mesg->content;
	if(!is_integer($parent) || $name == "") {
		$mesg->subject = ERROR;
		$mesg->content = LNK_EMPTY_VALUE;
		debug(ERROR, LINKER_NAME, $mesg->content);
		return $mesg;
	}
	if($parent != 0) {
		$mesg = linker_get_tag($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$ttag = $mesg->content;	
		$level = $mesg->get_header("Level") + 1;
	} else {
		$ttag = "|";
		$level = 1;
	}
	$mesg->set(KEEPER_NAME, LINKER_NAME, "insert");
	$mesg->set_header("DBName", LINKER_DB);
	$mesg->content = "INSERT INTO " . TREE_TBL
			. "(parent_id, name) values ($parent, \"" . pit($name) . "\")";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$lid = $mesg->content;
	$ttag .= "$lid|";
	$mesg->set(KEEPER_NAME, LINKER_NAME, "query");
	$mesg->set_header("DBName", LINKER_DB);
	$mesg->content = "UPDATE " . TREE_TBL . " SET tag = \"$ttag\""
				. ", level = $level where id = $lid";
	return send_message($mesg);
}
function linker_recv_mesg($mesg)
{
	$result = new Message($mesg->from, LINKER_NAME, OK);
	switch($mesg->subject) {
		case "init_db" :
			$result = linker_init_db();
			break;
		case "destroy_db" :
			$result = linker_destroy_db();
			break;
		case "add" :
			$result = linker_add($mesg);
			break;
		case "del" :
			$result = linker_del($mesg);
			break;
		case "get_flist" :
			$result = linker_get_flist($mesg);
			break;
		case "get_tag" :
			$result = linker_get_tag($mesg);
			break;
		case "get_name" :
			$result = linker_get_name($mesg);
			break;
		default :
			$result->content = LNK_UNKNOW_CMD;
			$result->subject = ERROR;
			debug(ERROR, LINKER_NAME, $result->content);
	}
	return $result;
}
?>
