<?php
# $Id: manager.php,v 1.3 2003/01/06 03:20:32 pruet Exp $
# manager - User Manager Agent
define("MANAGER_VER", "0.0.2");
define("MANAGER_NAME", "manager");
define("MANAGER_RECV_MESG", TRUE);
define("MANAGER_DB", DEFAULT_DB);
define("ACCOUNT_TBL", "account");
define("FRIEND_TBL", "friend");
define("MNG_EMPTY_VALUE", 100);
define("MNG_PWD_ERROR", 101);
define("MNG_USER_ERROR", 102);
define("MNG_USER_EXIST", 103);
define("MNG_TIME_OUT", 104);
define("MNG_UNKNOW_CMD", 105);

function manager_destroy_db()
{
	$mesg = new Message(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "DROP TABLE " . ACCOUNT_TBL . "," . FRIEND_TBL;
	return send_message($mesg);
}
function manager_init_db()
{
	$mesg = new Message(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "CREATE TABLE  " . ACCOUNT_TBL . " ("
			. "user_id SERIAL PRIMARY KEY, "
			. "login VARCHAR(30) NOT NULL, "
			. "passwd VARCHAR(30) NOT NULL, "
			. "email VARCHAR(255) NOT NULL, "
			. "name VARCHAR(255) NOT NULL, "
			. "session VARCHAR(255), "
			. "time BIGINT, "
			. "level INT2 NOT NULL DEFAULT 0, "
			. "host VARCHAR(255)) ";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->content = "CREATE TABLE " . FRIEND_TBL . " ("
			. "id SERIAL, " 
			. "owner_id int4 NOT NULL, "
			. "friend_id int4 NOT NULL, "
			. "group_id int4 NOT NULL, "
			. "comment varchar (255) DEFAULT '' NOT NULL, "
			. "add_date date DEFAULT date('now'::text) NOT NULL, "
			. "flag int2 NOT NULL );";
	return send_message($mesg);
}
function manager_user_del($mesg)
{
	$login = $mesg->get_header("login");
	if($login == "") {
		$mesg->subject = ERROR;
		$mesg->content = MNG_EMPTY_VALUE;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "DELETE FROM " . ACCOUNT_TBL . " WHERE LOGIN = '" . $login . "'";
	return send_message($mesg);
}
function manager_friend_del($mesg)
{
	$owner_id = $mesg->get_header("owner_id");
	$friend_id = $mesg->get_header("friend_id");
	if($owner_id == "" || $friend_id == "") {
		$mesg->subject = ERROR;
		$mesg->content = MNG_EMPTY_VALUE;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "SELECT friend_id FROM " . FRIEND_TBL . " WHERE owner_id = '" . $owner_id . "' and friend_id = '" . $friend_id . "'";
	$mesg =  send_message($mesg);
	if($mesg->subject != OK) {
		return($mesg);
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content <= 0) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_USER_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "DELETE FROM " . FRIEND_TBL . " WHERE owner_id = '" . $owner_id . "' and friend_id = '" . $friend_id . "'";
	return send_message($mesg);
}
function manager_friend_add($mesg)
{
	$owner_id = $mesg->get_header("owner_id");
	$friend_id = $mesg->get_header("friend_id");
	if($owner_id == "" || $friend_id == "") {
		$mesg->subject = ERROR;
		$mesg->content = MNG_EMPTY_VALUE;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "SELECT friend_id FROM " . FRIEND_TBL . " WHERE owner_id = '" . $owner_id . "' and friend_id = '" . $friend_id . "'";
	$mesg =  send_message($mesg);
	if($mesg->subject != OK) {
		return($mesg);
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content > 0) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_USER_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->content = "INSERT INTO " . FRIEND_TBL . " (owner_id, friend_id) VALUES($owner_id, $friend_id)";
	return(send_message($mesg));
}
function manager_user_info($mesg)
{
	$login = $mesg->get_header("login");
	$user_id = $mesg->get_header("user_id");
	if($login == "" && $user_id == "") {
		$mesg->subject = ERROR;
		$mesg->content = MNG_EMPTY_VALUE;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	if($user_id == "") {
		$mesg->content = "SELECT login, user_id, email, name, host, level FROM " . ACCOUNT_TBL . " where login = '$login'";
	} else {
		$mesg->content = "SELECT login, user_id, email, name, host, level FROM " . ACCOUNT_TBL . " where user_id = '$user_id'";
	}
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content <= 0) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_USER_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "fetch");
	return send_message($mesg);
}
function manager_user_add($mesg)
{
	$login = $mesg->get_header("login");
	$password = $mesg->get_header("password");
	$repassword = $mesg->get_header("repassword");
	$email = $mesg->get_header("email");
	$name = $mesg->get_header("name");
	$level = $mesg->get_header("level");
	if($login == "" || $password == "" || $email == "" || $name == "") {
		$mesg->subject = ERROR;
		$mesg->content = MNG_EMPTY_VALUE;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}

	if($password != $repassword) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_PWD_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	if($level == "") {
		$level = "0";
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "SELECT user_id FROM " . ACCOUNT_TBL . " WHERE login = '$login'";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content > 0) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_USER_EXIST;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "insert");
	$mesg->content = "INSERT INTO " . ACCOUNT_TBL . " ( "
			. " login, passwd, email, name, level ) VALUES ( "
			. "'" . pot($login) . "','$password','" . pot($email) . "','" . pot($name) . "'," . pot($level) . ")";
	return(send_message($mesg));
}
function manager_user_update($mesg)
{
	$user_id = $mesg->get_header("user_id");
	$login = $mesg->get_header("login");
	$password = $mesg->get_header("password");
	$repassword = $mesg->get_header("repassword");
	$email = $mesg->get_header("email");
	$name = $mesg->get_header("name");
	if($user_id == "" && $login == "") {
		$mesg->subject = ERROR;
		$mesg->content = MNG_EMPTY_VALUE;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	if($user_id == "") {
		$mesg->set_header("login", $login);
		$mesg = manager_user_info($mesg);
		$user_id = $mesg->content[user_id];
	}
	if($password != $repassword) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_PWD_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "SELECT user_id from " . ACCOUNT_TBL . " WHERE login = '$login'";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content <= 0) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_USER_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	if($password == "") {
		$mesg->content = "UPDATE " . ACCOUNT_TBL . " SET email = '" . pot($email) . "',"
				. " name = '" . pot($name) . "' WHERE user_id = $user_id";
	} else {
		$mesg->content = "UPDATE " . ACCOUNT_TBL . " SET email = '" . pot($email) . "',"
				. " passwd = '$password', name = '" . pot($name) . "' WHERE user_id = $user_id";
	}
	return(send_message($mesg));
}
function manager_logout($mesg)
{
	$session = $mesg->get_header("session");
	if($session == "") {
		$mesg->subject = ERROR;
		$mesg->content = MNG_EMPTY_VALUE;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "UPDATE " . ACCOUNT_TBL . " SET session = '', time = 0 WHERE session = '$session'";
	return send_message($mesg);
}
function manager_num_login($mesg)
{
	$timeout = $mesg->get_header("timeout");
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	if($timeout == "") {
		$mesg->content = "SELECT count(user_id) AS counter FROM " . ACCOUNT_TBL . " WHERE session != ''";
	} else {
		$timeout = time() - $timeout;
		$mesg->content = "SELECT count(user_id) AS counter FROM " . ACCOUNT_TBL . " WHERE session != '' AND time >  $timeout";
	}
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "result");
	$mesg->set_header("DBRow", 0);
	$mesg->set_header("DBField", "counter");
	return send_message($mesg);
}
function manager_user_all($mesg)
{
	$start = $mesg->get_header("start");
	$limit = $mesg->get_header("limit");
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
 	$mesg->content = "SELECT user_id, login, host, session, time FROM " . ACCOUNT_TBL . " order by lower(login)
limit $start, $limit";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}

	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$numrows = $mesg->content;

	$user_list = array();
	for($i = 0; $i != $numrows; $i++) {
		$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$user_list[$i] = $mesg->content;
	}
	$mesg->subject = OK;
	$mesg->set_header("UserNum", $numrows);
	$mesg->content = $user_list;
	return $mesg;
}

function manager_friend_all($mesg)
{
	$owner_id = $mesg->get_header("owner_id");
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "SELECT user_id, login, host, session, time FROM " . ACCOUNT_TBL . " left join " . FRIEND_TBL . " on " . ACCOUNT_TBL . ".user_id = " . FRIEND_TBL . ".friend_id  where " . FRIEND_TBL . ".owner_id = " . $owner_id . " order by lower(login)";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$numrows = $mesg->content;
	$user_list = array();
	for($i = 0; $i != $numrows; $i++) {
		$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$user_list[$i] = $mesg->content;
	}
	$mesg->subject = OK;
	$mesg->set_header("UserNum", $numrows);
	$mesg->content = $user_list;
	return $mesg;
}

function manager_user_login($mesg)
{
	$timeout = $mesg->get_header("timeout");
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	if($timeout == "") {
		$mesg->content = "SELECT user_id, login, host FROM " . ACCOUNT_TBL . " WHERE session != '' order by lower(login)";
	} else {
		$timeout = time() - $timeout;
		$mesg->content = "SELECT user_id, login, host FROM " . ACCOUNT_TBL . " WHERE session != '' AND time > $timeout order by lower(login)";
	}
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$numrows = $mesg->content;
	$user_list = array();
	for($i = 0; $i != $numrows; $i++) {
		$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$user_list[$i] = $mesg->content;
	}
	$mesg->subject = OK;
	$mesg->set_header("UserNum", $numrows);
	$mesg->content = $user_list;
	return $mesg;
}
function manager_num_all($mesg)
{
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "SELECT count(user_id) AS counter FROM " . ACCOUNT_TBL;
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "result");
	$mesg->set_header("DBRow", 0);
	$mesg->set_header("DBField", "counter");
	return send_message($mesg);
}
function manager_user_id($mesg)
{
	$session = $mesg->get_header("session");
	if($session == "") {
		$mesg->subject = ERROR;
		$mesg->content = MNG_VALUE_EMPTY;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "SELECT user_id from " . ACCOUNT_TBL . " WHERE session = '$session'";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content <= 0) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_USER_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "result");
	$mesg->set_header_array(array(
		"DBRow" => 0,
		"DBField" => "user_id"
	));
	return send_message($mesg);
}
function manager_check($mesg)
{
	$session = $mesg->get_header("session");
	$timeout = $mesg->get_header("timeout");
	if($session == "") {
		$mesg->subject = ERROR;
		$mesg->content = MNG_EMPTY_VALUE;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "SELECT time FROM " . ACCOUNT_TBL . " WHERE (account.session = '$session')";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content <= 0) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_USER_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	if($timeout != "") {
		$mesg->set(KEEPER_NAME, MANAGER_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$time = $mesg->content[time];
		if(time() > ($time + $timeout)) {
			$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
			$mesg->content = "UPDATE " . ACCOUNT_TBL . " SET session = '', time = 0 WHERE (account.session = '$session')";
			$mesg = send_message($mesg);
			$mesg->subject = ERROR;
			$mesg->content = MNG_TIME_OUT;
			debug(ERROR, MANAGER_NAME, $mesg->content);
			return $mesg;
		}
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->content = "UPDATE " . ACCOUNT_TBL . " SET time = '" . time() . "' WHERE (account.session = '$session')";
	return send_message($mesg);
}
function manager_login($mesg)
{
	$login = $mesg->get_header("login");
	$password = $mesg->get_header("password");
	$host = $mesg->get_header("host");
	$session = $mesg->get_header("session");
	if($session == "") {
		$mesg->set($mesg->from, $mesg->to, "ERROR");
		$mesg->content = MNG_SESSION_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	if($login == "" || $password == "") {
		$mesg->set($mesg->from, $mesg->to, "ERROR");
		$mesg->content = MNG_EMPTY_VALUE;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->set_header("DBName", MANAGER_DB);
	$mesg->content = "SELECT user_id FROM " . ACCOUNT_TBL . " WHERE "
			. " (account.login = '" . pot($login) . "'  AND account.passwd = '$password')";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content <= 0) {
		$mesg->subject = ERROR;
		$mesg->content = MNG_USER_ERROR;
		debug(ERROR, MANAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "fetch");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$id = $mesg->content[user_id];
	$mesg->set(KEEPER_NAME, MANAGER_NAME, "query");
	$mesg->content = "UPDATE " . ACCOUNT_TBL . "  SET session = '$session', time = '" . time() . "'"
			. ", host = '$host' WHERE (account.user_id = $id)";
	return send_message($mesg);
}
function manager_recv_mesg($mesg)
{
	$result = new Message($mesg->from, MANAGER, OK);
	switch($mesg->subject) {
		case "init_db" :
			$result = manager_init_db();
			break;
		case "destroy_db" :
			$result = manager_destroy_db();
			break;
		case "check" :
			$result = manager_check($mesg);
			break;
		case "login" :
			$result = manager_login($mesg);
			break;
		case "logout" :
			$result = manager_logout($mesg);
			break;
		case "user_add" :
			$result = manager_user_add($mesg);
			break;
		case "user_del" :
			$result = manager_user_del($mesg);
			break;
		case "user_info" :
			$result = manager_user_info($mesg);
			break;
		case "user_update" :
			$result = manager_user_update($mesg);
			break;
		case "num_login" :
			$result = manager_num_login($mesg);
			break;
		case "user_login" :
			$result = manager_user_login($mesg);
			break;
		case "user_all" :
			$result = manager_user_all($mesg);
			break;
		case "num_all" :
			$result = manager_num_all($mesg);
			break;
		case "user_id" :
			$result = manager_user_id($mesg);
			break;
		case "friend_add" :
			$result = manager_friend_add($mesg);
			break;
		case "friend_del" :
			$result = manager_friend_del($mesg);
			break;
		case "friend_all" :
			$result = manager_friend_all($mesg);
			break;
		default :
			$result->content = MNG_UNKNOW_CMD;
			$result->subject = ERROR;
			debug(ERROR, MANAGER_NAME, $result->content);
	}
	return $result;
}
?>
