<?php
# $Id: messager.php,v 1.1.1.1 2003/01/03 10:42:07 pruet Exp $
# messager - User Messager Mill Agent
define("MESSAGER_VER", "0.0.1");
define("MESSAGER_NAME", "messager");
define("MESSAGER_RECV_MESG", TRUE);
define("MESSAGER_DB", DEFAULT_DB);
define("MESSAGER_TBL", "message");
define("MSG_EMPTY_VALUE" , 100);
define("MSG_NO_MESSAGE", 101);
define("MSG_SEQ_NUMBER", 102);
define("MSG_NO_DELETE", 103);
function messager_destroy_db()
{
	$mesg = new Message(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "DROP TABLE " . MESSAGER_TBL;
	return send_message($mesg);
}
function messager_init_db()
{
	$mesg = new Message(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "CREATE TABLE " . MESSAGER_TBL . " ("
			. "id SERIAL PRIMARY KEY, "
			. "sender INT NOT NULL, "
			. "receiver INT NOT NULL, "
			. "timestamp BIGINT NOT NULL, "
			. "status varCHAR(1) DEFAULT 'u', "
			. "subject varCHAR(255) DEFAULT 'New message', "
			. "content TEXT)";
	return send_message($mesg);
}
function messager_send($mesg)
{
	$sender = (int)$mesg->get_header("sender");
	$receiver = (int)$mesg->get_header("receiver");
	$subject = $mesg->get_header("subject");
	$content = $mesg->content;
	if($sender == "" || $receiver == "" || !is_integer($sender) || !is_integer($sender)) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_EMPTY_VALUE;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "INSERT INTO " . MESSAGER_TBL
				. "(sender, receiver, timestamp, subject, content) values ( "
				. "$sender,$receiver," . time() . ",'" . pit($subject) . "','" . pit($content) . "')";
	return send_message($mesg);
}
function messager_get_all($mesg)
{
	$uid = (int)$mesg->get_header("receiver");
	if($uid == "" || !is_integer($uid)) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_EMPTY_VALUE;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg = messager_check($mesg);
	if($mesg->subject != OK || $mesg->content <= 0) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_NO_MESSAGE;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "select id, content, subject, sender, timestamp, status from " . MESSAGER_TBL . " where receiver = $uid and (status = 'u' or status = 'r') order by timestamp desc";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$numrows = $mesg->content;
	$amesg = array();
	$emesg = new Message("", "", "");
	$i = 0;
	while($i != $numrows) {
		$mesg->set(KEEPER_NAME, MESSAGER_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$emesg->set($mesg->content[receiver], $mesg->content[sender], $mesg->content[subject]);
		$i++;
		$emesg->set_header("SeqNumber", $i);
		$emesg->set_header("MesgID", $mesg->content[id]);
		$emesg->set_header("Status", $mesg->content[status]);
		$emesg->content = $mesg->content[content];
		$emesg->time = $mesg->content[timestamp];
		$amesg[] = $emesg;
	}
	$mesg->subject = OK;
	$mesg->set_header("NumMessages",$numrows);
	$mesg->content = $amesg;
	return $mesg;
}
function messager_get($mesg)
{
	$seq = (int)$mesg->get_header("sequence");
	$recv = (int)$mesg->get_header("receiver");
	if($recv == "" || !is_integer($recv)) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_EMPTY_VALUE;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	if($seq == "" || !is_integer($seq)) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_SEQ_NUMBER;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "update " . MESSAGER_TBL . " set status = 'r' where id = $seq and receiver = $recv";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "select content, subject, sender, timestamp, status from " . MESSAGER_TBL . " where id = $seq and receiver = $recv";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "fetch");
	return send_message($mesg);
}
function messager_del_all($mesg)
{
	$uid = (int)$mesg->get_header("receiver");
	if($uid == "" || !is_integer($uid)) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_EMPTY_VALUE;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg = messager_check($mesg);
	if($mesg->subject != OK || $mesg->content <= 0) {
		$mesg->subject = WARNING;
		$mesg->content = MSG_NO_MESSAGE;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "update " . MESSAGER_TBL . " set status = 'd' where receiver = $uid and status = 'r'";
	return send_message($mesg);
}
function messager_del($mesg)
{
	$mid = (int)$mesg->get_header("message_id");
	$recv = (int)$mesg->get_header("receiver");
	if(!is_integer($recv)) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_EMPTY_VALUE;
		debug(ERROR, MESSAGER_NAME, $mseg->content);
		return $mesg;
	}
	if(!is_integer($mid)) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_SEQ_NUMBER;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "update " . MESSAGER_TBL . " set status = 'd' where id = $mid and receiver = $recv";
	$mesg = send_message($mesg);
	if($mesg->get_header("DBResult") == 0) {
		$mesg->subject = WARNING;
		$mesg->content = MSG_NO_DELETE;
	}
	return $mesg;
}
function messager_check_new($mesg)
{
	$uid = (int)$mesg->get_header("receiver");
	if($uid == "" || !is_integer($uid)) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_EMPTY_VALUE;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "SELECT count(id) as counter from " . MESSAGER_TBL . " where receiver = '$uid' and status = 'u'";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "result");
	$mesg->set_header("DBRow", 0);
	$mesg->set_header("DBField", "counter");
	return send_message($mesg);
}
function messager_check($mesg)
{
	$uid = (int)$mesg->get_header("receiver");
	if($uid == "" || !is_integer($uid)) {
		$mesg->subject = ERROR;
		$mesg->content = MSG_EMPTY_VALUE;
		debug(ERROR, MESSAGER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "query");
	$mesg->set_header("DBName", MESSAGER_DB);
	$mesg->content = "SELECT count(id) as counter from " . MESSAGER_TBL . " where receiver = '$uid' and (status = 'u' or status = 'r')";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MESSAGER_NAME, "result");
	$mesg->set_header("DBRow", 0);
	$mesg->set_header("DBField", "counter");
	return send_message($mesg);
}
function messager_recv_mesg($mesg)
{
	$result = new Message($mesg->from, MESSAGER, OK);
	switch($mesg->subject) {
		case "init_db" :
			$result = messager_init_db();
			break;
		case "destroy_db" :
			$result = messager_destroy_db();
			break;
		case "send" :
			$result = messager_send($mesg);
			break;
		case "check" :
			$result = messager_check($mesg);
			break;
		case "check_new" :
			$result = messager_check_new($mesg);
			break;
		case "get" :
			$result = messager_get($mesg);
			break;
		case "get_all" :
			$result = messager_get_all($mesg);
			break;
		case "del" :
			$result = messager_del($mesg);
			break;
		case "del_all" :
			$result = messager_del_all($mesg);
			break;
		default :
			$result->content = "Unknow command [" . $result->subject . "]";
			$result->subject = ERROR;
			debug(ERROR, MESSAGER_NAME, $result->content);
	}
	return $result;
}
