<?php
# $Id: publisher.php,v 1.1.1.1 2003/01/03 10:42:07 pruet Exp $
# Plublisher - Article Publisher Agent
define("PUBLISHER_VER", "0.0.1");
define("PUBLISHER_NAME", "publisher");
define("PUBLISHER_RECV_MESG", TRUE);
define("PUBLISHER_DB", DEFAULT_DB);
define("ARTICLE_TBL", "article");
define("ARTICLE_PART_TBL", "article_part");
define("PBS_EMPTY_VALUE", 100);
/*define("PBS_PWD_ERROR", 101);
define("PBS_USER_ERROR", 102);
define("PBS_USER_EXIST", 103);
define("PBS_TIME_OUT", 104);*/
define("PBS_UNKNOW_CMD", 105);

function publisher_destroy_db()
{
	$mesg = new Message(KEEPER_NAME, PUBLISHER_NAME, "query");
	$mesg->set_header("DBName", PUBLISHER_DB);
	$mesg->content = "DROP TABLE " . ARTICLE_TBL;
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, PUBLISHER_NAME, "query");
	$mesg->content = "DROP TABLE " . ARTICLE_PART_TBL;
	return send_message($mesg);
}
function publisher_init_db()
{
	$mesg = new Message(KEEPER_NAME, PUBLISHER_NAME, "query");
	$mesg->set_header("DBName", PUBLISHER_DB);
	$mesg->content = "CREATE TABLE  " . ARTICLE_TBL . " ("
			. "id SERIAL PRIMARY KEY, "
			. "cat INT NOT NULL, "
			. "name CHAR(255) NOT NULL, "
			. "author INT NOT NULL, "
			. "timestamp BIGINT NOT NULL, "
			. "level TINYINT NOT NULL )";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	//$mesg->set(KEEPER_NAME, PUBLISHER_NAME, "query");
	return send_message($mesg);
}
function publisher_get_tag($mesg)
{
	$id = (int)$mesg->get_header("id");
	$parent = (int)$mesg->get_header("parent");
	if(($id == "" || !is_integer($id) || $id == 0) && ($parent == "" || !is_integer($parent) || $parent == 0)) {
		$mesg->subject = ERROR;
		$mesg->content = PBS_EMPTY_VALUE;
		debug(ERROR, PUBLISHER_NAME, $mesg->content);
		return $mesg;
	}
	$id = ($id == "") ? $parent : $id;
	$mesg->set(KEEPER_NAME, PUBLISHER_NAME, "query");
	$mesg->content = "select tag, level from " . ARTICLE_TBL . " where id = $id";
	$mesg->set_header("DBName", PUBLISHER_DB);
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, PUBLISHER_NAME, "fetch");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set_header("Level", $mesg->content[level]);
	$mesg->content = $mesg->content[tag];
	return $mesg;
}
function publisher_get_flist($mesg)
{
	$parent = (int)$mesg->get_header("parent");
	if($parent == "")
		$parent = 0;
	if(!is_integer($parent)) {
		$mesg->subject = ERROR;
		$mesg->content = PBS_EMPTY_VALUE;
		debug(ERROR, PUBLISHER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, PUBLISHER_NAME, "query");
	$mesg->set_header("DBName", PUBLISHER_DB);
	if($parent == 0) {
		$mesg->content = "select id, tag, name, level, parent_id from " . ARTICLE_TBL . " order by id";
	} else {
		$mesg->content = "select id, tag, name, level, parent_id from " . ARTICLE_TBL . " where tag like '%|$parent|%' order by id";
	}
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, PUBLISHER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$numrows = $mesg->content;
	$flist = array();
	for($i = 0; $i != $numrows; $i++) {
		$mesg->set(KEEPER_NAME, PUBLISHER_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$flist[$mesg->content[id]] = array(
			"name" => $mesg->content[name],
			"level" => $mesg->content[level],
			"parent_id" => $mesg->content[parent_id],
			"tag" => explode("|", $mesg->content[tag])
		);
	}
	$mesg->subject = OK;
	$mesg->set_header("NumParent", $numrows);
	uasort($flist, loopsort);
	$mesg->content = $flist;
	return $mesg;
}
function publisher_del($mesg)
{
	$parent = (int)$mesg->get_header("parent");
	if(!is_integer($parent)) {
		$mesg->subject = ERROR;
		$mesg->content = PBS_EMPTY_VALUE;
		debug(ERROR, PUBLISHER_NAME, $mesg->content);
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, LIKER_NAME, "query");
	$mesg->set_header("DBName", LIKER_NAME);
	$mesg->content = "DELETE FROM " . ARTICLE_TBL
		. " where tag like \"%|$parent|%\"";
	return send_message($mesg);
}
function publisher_add($mesg)
{
	$parent = (int)$mesg->get_header("parent");
	$name = $mesg->content;
	if(!is_integer($parent) || $name == "") {
		$mesg->subject = ERROR;
		$mesg->content = PBS_EMPTY_VALUE;
		debug(ERROR, PUBLISHER_NAME, $mesg->content);
		return $mesg;
	}
	if($parent != 0) {
		$mesg = publisher_get_tag($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$ttag = $mesg->content;	
		$level = $mesg->get_header("Level") + 1;
	} else {
		$ttag = "|";
		$level = 1;
	}
	$mesg->set(KEEPER_NAME, PUBLISHER_NAME, "insert");
	$mesg->set_header("DBName", PUBLISHER_DB);
	$mesg->content = "INSERT INTO " . ARTICLE_TBL
			. "(parent_id, name) values ($parent, \"" . pit($name) . "\")";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$lid = $mesg->content;
	$ttag .= "$lid|";
	$mesg->set(KEEPER_NAME, PUBLISHER_NAME, "query");
	$mesg->set_header("DBName", PUBLISHER_DB);
	$mesg->content = "UPDATE " . ARTICLE_TBL . " SET tag = \"$ttag\""
				. ", level = $level where id = $lid";
	return send_message($mesg);
}
function publisher_recv_mesg($mesg)
{
	$result = new Message($mesg->from, PUBLISHER_NAME, OK);
	switch($mesg->subject) {
		case "init_db" :
			$result = publisher_init_db();
			break;
		case "destroy_db" :
			$result = publisher_destroy_db();
			break;
		case "add" :
			$result = publisher_add($mesg);
			break;
		case "del" :
			$result = publisher_del($mesg);
			break;
		case "get_flist" :
			$result = publisher_get_flist($mesg);
			break;
		default :
			$result->content = PBS_UNKNOW_CMD;
			$result->subject = ERROR;
			debug(ERROR, PUBLISHER_NAME, $result->content);
	}
	return $result;
}
?>
