<?php
# $Id: voter.php,v 1.1.1.1 2003/01/03 10:42:07 pruet Exp $
# Voter - Vote Manager Agent
define("VOTER_VER", "0.0.1");
define("VOTER_NAME", "voter");
define("VOTER_RECV_MESG", TRUE);
define("VOTER_DB", DEFAULT_DB);
define("VOTER_TOPIC_TBL", "vote_topic");
define("VOTER_ITEM_TBL", "vote_item");
define("VOTER_DATA_TBL", "vote_data");
define("VTR_UNKNOW_CMD", 100);
define("VTR_EMPTY_VALUE", 200);
define("VTR_WRONG_VALUE", 201);
define("VTR_TOPIC_ERR", 300);

function voter_destroy_db()
{
	$mesg = new Message(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "DROP TABLE " . VOTER_TOPIC_TBL;
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return($mesg);
	}
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "DROP TABLE " . VOTER_ITEM_TBL;
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return($mesg);
	}
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "DROP TABLE " . VOTER_DATA_TBL;
	return send_message($mesg);
}
function voter_init_db()
{
	$mesg = new Message(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "CREATE TABLE  " . VOTER_TOPIC_TBL . " ("
			. "vote_topic_id SERIAL PRIMARY KEY, "
			. "topic VARCHAR(255) NOT NULL, "
			. "start_time INT NOT NULL, "
			. "stop_time INT NOT NULL, "
			. "create_id INT) ";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return($mesg);
	}
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "CREATE TABLE  " . VOTER_ITEM_TBL . " ("
			. "vote_item_id SERIAL PRIMARY KEY, "
			. "vote_topic_id INT NOT NULL, "
			. "item VARCHAR(255) NOT NULL, "
			. "count INT DEFAULT 0) ";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return($mesg);
	}
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "CREATE TABLE " . VOTER_DATA_TBL . " ("
			. "vote_data_id SERIAL PRIMARY KEY, "
			. "vote_topic_id INT NOT NULL, "
			. "vote_item_id INT NOT NULL, "
			. "user_id INT NOT NULL, "
			. "vote_time INT NOT NULL) ";
	return send_message($mesg);
}
function voter_new_poll($mesg)
{
	$topic = $mesg->get_header("topic");
	$create_id = (int)$mesg->get_header("creater");
	$start_time = (int)$mesg->get_header("start_time");
	$stop_time = (int)$mesg->get_header("stop_time");
	$item = $mesg->content;
	$item_num = count($item);
	if($topic == "" || $creater_id == "" || $start_time == "" || $stop_time == "") {
		$mesg->subject = ERROR;
		$mesg->content = VTR_EMPTY_VALUE;
		return $mesg;
	}
	if($start_time >= $stop_time || $item_num < 2) {
		$mesg->subject = ERROR;
		$mesg->content = VTR_WRONG_VALUE;
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "SELECT voter_topic_id FROM " . VOTER_TOPIC_TBL . " WHERE topic = \"$content\"";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content != 0) {
		$mesg->subject = ERROR;
		$mesg->content = VTR_TOPIC_ERR;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "insert");
	$mesg->content = "INSERT into " . VOTER_TOPIC_TBL
		. " (topic,	start_time, stop_time, creater_id ) VALUES "
		. " (\"" . pit($topic) . "\", $start_time, $stop_time, $creater_id) ";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$topic_id = $mesg->content;
	for($i = 0; $i != $topic_num; $i++) {
		$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
		$mesg->content = "INSERT into " . VOTER_ITEM_TBL
			. " (vote_topic_id, item) values "
			. " ($topic_id, \"" . pit($item[$i]) . "\")";
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
	}
	return $mesg;
}
function voter_del_poll($mesg)
{
	$poll_id = (int)$mesg->get_header("poll_id");
	if($poll_id == "") {
		$mesg->subject = ERROR;
		$mesg->content = VTR_EMPTY_VALUE;
		return $mesg;
	} 
	$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "select voter_topic_id from " . VOTER_TOPIC_TBL . " where voter_topic_id = $poll_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content == 0) {
		$mesg->subject = ERROR;
		$mesg->content = VTR_TOPIC_ERR;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->content = "delete from " . VOTER_TOPIC_TBL . " where voter_topic_id = $topic_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->content = "delete from " . VOTER_ITEM_TBL . " where voter_topic_id = $topic_id";
	return(send_message($mesg));
}
function voter_new_vote($mesg)
{
	$vote_id = (int)$mesg->get_header("vote_id");
	$user_id = (int)$mesg->get_header("user_id");
	if($vote_id == "" || $user_id == "") {
		$mesg->subject = ERROR;
		$mesg->content = VTR_EMPTY_VALUE;
		return $mesg;
	} 
	$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "select vote_item_id, vote_topic_id from " . VOTER_ITEM_TBL . " where voter_item_id = $vote_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content == 0) {
		$mesg->subject = ERROR;
		$mesg->content = VTR_TOPIC_ERR;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "fetch");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$topic_id = $mesg->content[vote_topic_id];
	$mesg->set(MANAGER_NAME, VOTER_NAME, "user_info");
	$mesg->set_header("user_id", $user_id);
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "INSERT INTO " . VOTER_DATA_TBL . " ( "
		. " vote_topic_id, vote_item_id, user_id, vote_time ) VALUES ( "
		. " $topic_id, $vote_id, $user_id, " . time() . ")";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->content = "UPDATE " . VOTER_ITEM_TBL . " set count = count + 1 WHERE "
		. " voter_item_id = $vote_id ";
	return send_message($mesg);
}
function voter_poll_result($mesg)
{
	$poll_id = (int)$mesg->get_header("poll_id");
	if($poll_id == "") {
		$mesg->subject = ERROR;
		$mesg->content = VTR_EMPTY_VALUE;
		return $mesg;
	} 
	$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->set_header("DBName", VOTER_DB);
	$mesg->content = "SELECT vote_topic_id from " . VOTER_TOPIC_TBL . " where voter_topic_id = $poll_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content == 0) {
		$mesg->subject = ERROR;
		$mesg->content = VTR_TOPIC_ERR;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "query");
	$mesg->content = "SELECT vote_item_id, item, count FROM " . VOTER_ITEM_TBL
		. " WHERE vote_topic_id = $poll_id ORDER BY vote_item_id ";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, VOTER_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	if($mesg->content == 0) {
		$mesg->subject = ERROR;
		$mesg->content = VTR_TOPIC_ERR;
	}
	$count = $mesg->content;
	$item_id_array = array();
	$item_name_array = array();
	$item_count_array = array();
	$i = 0;
	while($i != $count) {
		$mesg->set(KEEPER_NAME, VOTER_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return $mesg;
		}
		$item_id_array[$i] = $mesg->content[vote_item_id];
		$item_name_array[$i] = $mesg->content[item];
		$item_count_array[$i] = $mesg->content[count];
	}
	$mesg->subject = OK;
	$mesg->set_header("ItemName", $count);
	$mesg->set_header("ItemID" , $item_id_array);
	$mesg->set_header("ItemName", $item_name_array);
	$mesg->content = $item_count_array;
	return $mesg;
}
function voter_recv_mesg($mesg)
{
	$result = new Message($mesg->from, VOTER_NAME, OK);
	switch($mesg->subject) {
		case "init_db" :
			$result = voter_init_db();
			break;
		case "destroy_db" :
			$result = voter_destroy_db();
			break;
		case "add_poll" :
			$result = voter_new_poll($mesg);
			break;
		case "del_poll" :
			$result = voter_del_poll($mesg);
			break;
		case "poll_result" :
			$result = voter_poll_result($mesg);
			break;
		case "new_vote" :
			$result = voter_new_vote($mesg);
			break;
		default :
			$result->content = VTR_UNKNOW_CMD;
			$result->subject = ERROR;
			debug(ERROR, VOTER_NAME, $result->content);
	}
	return $result;
}
?>
