#!/usr/bin/perl
#  Copyright (C) 1999,2000 by Pruet Boonma <pruet@eng.cmu.ac.th
#  the GPL (Gnu Public License) applies. See http://software.thai.net/gpl.html
#  for more information.
# $Id: myshout_low.pl,v 1.1.1.1 2003/01/03 10:42:07 pruet Exp $
# You need Shout and MySQL module. find it at CPAN mirrors near you.

use strict;
use DBI;

BEGIN {
	use Shout qw{};
}

use vars qw{$Debug $Lame};

#config
$Debug = 0;
my $Bitrate = 32;
my $Host = "localhost";
my $Port = "6000";
my $Mount = "general_low";
my $Password = "engneverdie";
my $Name = "MPTC MP3Stataion/Low Bit Rate";
my $URL = "http://mptc.eng.cmu.ac.th/mp3station/";
my $Genre = "Thai and English Music";
my $path = "/home/mp3station/";
my $db_driver = "dbi:Pg:dbname=mp3station;host=localhost";
my $db_login = "www-data";
my $db_passwd = "www-data";
my $station_id = 0;
my $dbh;
my $sth;
my $num_song;
my $result;
my $playqueue;
my $comment;
my $song;
my $album;
my $file;
my $request_id;

#Unmak this line if you want to use lame to desampling the file, lame must be installed in the system.
chomp($Lame = `which lame`);

my $streamer = new Shout
	ip => $Host,
	port => $Port,
	mount => $Mount,
	password => $Password,
	name => $Name,
	url => $URL,
	genre => $Genre,
	bitrate => $Bitrate;

if($streamer->connect) {
	printf "Connect to %s port %d......\n", $streamer->ip, $streamer->port if $Debug;
	printf "Will stream to mountpoint '%s', \n", $streamer->mount if $Debug;
} else {
	printf "Couldn't connect: %s\n", $streamer->error if $Debug;
	exit $streamer->shout_error;
}

$dbh  = DBI->connect($db_driver, $db_login, $db_passwd) || die "database_error";
while(1) {
	$sth = $dbh->prepare("SELECT song_id FROM station where station_id = ? LIMIT 1");
	$sth->execute($station_id);
	($result) = $sth->fetchrow_array;
	$sth = $dbh->prepare("SELECT songlist.song_name, albumlist.album_name FROM albumlist LEFT JOIN songlist ON albumlist.album_id = songlist.album_id WHERE songlist.song_id LIKE ?");
	$sth->execute($result);
	($song, $album) = $sth->fetchrow_array;
	$file = $path."/".$album."/".$song;
	$file =~ s/\n//g;
	print STDERR "\nCan't read [aaa$album][sss$song][fff$file]: $!" unless -e $file;
	print "play song [$file]\n" if $Debug;

	#Unmark next line for using lame to decrese the stream bitrate, you have to mark the next next line also.
	open( LAME, "-|" ) || exec "$Lame --silent -s 22.05  -b $Bitrate -m s '$file' -";
	#open(LAME, "$file");

	my $buff = '';
	while((my $len = sysread(LAME, $buff, 4096)) > 0) {
		print STDERR "Read $len bytes....\n" if $Debug;
		$streamer->sendData($buff) && next;
		warn("send failed: ", $streamer->error, "\n");
		last;
	} continue {
		$streamer->sleep;
	}

	close LAME;
}

$streamer->disconnect;
