#!/usr/bin/perl
#  Copyright (C) 1999,2000 by Pruet Boonma <pruet@eng.cmu.ac.th
#  the GPL (Gnu Public License) applies. See http://software.thai.net/gpl.html
#  for more information.
# $Id: myshout.pl,v 1.1.1.1 2003/01/03 10:42:07 pruet Exp $
# You need Shout and MySQL module. find it at CPAN mirrors near you.

use strict;
use DBI;

BEGIN {
        use Shout qw{};
}

use vars qw{$Debug $Lame};

#config
$Debug = 0;
my $Bitrate = 128;
my $Host = "localhost";
my $Port = "8000";
my $Mount = "station3";
my $Password = "hybridlive";
my $Name = "ʶҹԷ ԧ ӹѡ¹лż";
my $URL = "http://mail.reg.cmu.ac.th/regradio/";
my $Genre = "Thai and English Music";
my $path = "/home/mp3";
my $db_driver = "dbi:mysql:dbname=mp3;host=localhost";
my $db_login = "mp3";
my $db_passwd = "Mp3Station";
my $station_id = 3;
my $dbh;
my $sth;
my $num_song;
my $result;
my $playqueue;
my $comment;
my $song;
my $album;
my $file;
my $request_id;

#Unmak this line if you want to use lame to desampling the file, lame must be installed in the system.
#chomp($Lame = `which lame`);

my $streamer = new Shout
        ip => $Host,
        port => $Port,
        mount => $Mount,
        password => $Password,
        name => $Name,
        url => $URL,
        genre => $Genre,
        bitrate => $Bitrate;

if($streamer->connect) {
        printf "Connect to %s port %d......\n", $streamer->ip, $streamer->port if $Debug;
        printf "Will stream to mountpoint '%s', \n", $streamer->mount if $Debug;
} else {
        printf "Couldn't connect: %s\n", $streamer->error if $Debug;
        exit $streamer->shout_error;
}

$dbh  = DBI->connect($db_driver, $db_login, $db_passwd) || die "database_error";
$dbh->do("DELETE FROM station where station_id = $station_id");
$dbh->do("INSERT INTO station(song_id, request_id, comment, station_id) VALUES(0, 0, '', $station_id)");
while(1) {
        $sth = $dbh->prepare("SELECT song_id,playqueue FROM playqueue where station_id = ? and status = 'u' ORDER BY
playqueue LIMIT 1");
        $sth->execute($station_id);
        if($sth->rows == 0) {
        #no song in queue, try to random
                print "play random song\n" if $Debug;
                $sth = $dbh->prepare("SELECT song_id FROM songlist order by rand() limit 1");
                $sth->execute;
                ($result) = $sth->fetchrow_array;
                $dbh->do("UPDATE station SET song_id ='$result', request_id='0' , comment='' WHERE station_id='$station_id'");
        } else {
        #song in queue, play it.
                print "play from queue\n" if $Debug;
                ($result, $playqueue) = $sth->fetchrow_array;
                $sth = $dbh->prepare("SELECT request_id, comment FROM playqueue where playqueue=?");
                $sth->execute($playqueue);
                ($request_id, $comment) = $sth->fetchrow;
                $dbh->do("DELETE FROM playqueue WHERE  playqueue='$playqueue'");
                #$dbh->do("UPDATE playqueue SET status = 'p' WHERE  playqueue='$playqueue'");
                $dbh->do("insert into repeat set timestamp=unix_timestamp(),song_id='$result',station_id='$station_id'");
                $dbh->do("UPDATE station SET song_id ='$result', request_id ='$request_id', comment='$comment' WHERE station_id='$station_id'");
        }
        $dbh->do("UPDATE songlist SET play_count = play_count + 1 WHERE song_id ='$result'");
        $sth = $dbh->prepare("SELECT songlist.song_name, albumlist.album_name FROM albumlist LEFT JOIN songlist ON albumlist.album_id = songlist.album_id WHERE songlist.song_id LIKE ?");
        $dbh->do("OPTIMIZE TABLE station");
        $dbh->do("OPTIMIZE TABLE repeat");
        $dbh->do("OPTIMIZE TABLE playqueue");
        $sth->execute($result);
        ($song, $album) = $sth->fetchrow_array;
        $file = $path."/".$album."/".$song;
        $file =~ s/\n//g;
        print STDERR "\nCan't read [$album][$song][$file]: $!" unless -e $file;
        print "play song [$file]\n" if $Debug;

        #Unmark next line for using lame to decrese the stream bitrate, you have to mark the next next line also.
        #open( LAME, "-|" ) || exec "$Lame --mp3input -b $Bitrate -m j -S '$file' -";
        open(LAME, "$file");

        my $buff = '';
        while((my $len = sysread(LAME, $buff, 4096)) > 0) {
                print STDERR "Read $len bytes....\n" if $Debug;
                $streamer->sendData($buff) && next;
                warn("send failed: ", $streamer->error, "\n");
                last;
        } continue {
                $streamer->sleep;
        }

        close LAME;
}

$streamer->disconnect;
